package
{
	import flash.display.BitmapData;
	import flash.display.Shape;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	import flash.text.AntiAliasType;
	import flash.text.TextField;
	import flash.text.TextFieldAutoSize;
	import flash.text.TextFormat;
	import flash.ui.Mouse;
	import flash.utils.ByteArray;
	
	import org.flixel.*;
	import org.flixel.FlxSprite;
	import org.flixel.FlxState;
	import org.flixel.FlxU;
	
	public class GameState extends FlxState
	{	
		public static var canvas:FlxSprite;
		public var canvaspixels:ByteArray;
		public var canvaspixelsghost:ByteArray;
		
		public static var nhood:Vector.<Boolean>;
		
		public static const leftmargin:int=14;
		
		public static const vmargin1:int=0;
		public static const vmargin2:int=87;
		public static const vmargin3:int=188;
		
		[Embed(source="data/r1.png")] public static var r1:Class;
		[Embed(source="data/r2.png")] public static var r2:Class;
		
		
		public var sizebuttons:Vector.<FlxButton>;
		public var brushbuttons:Vector.<FlxButton>;
		
		public function randAutomata():void
		{
			AutomataManager.Create();
		}
		
		override public function create():void
		{
			AutomataManager.Create();
			sizebuttons = new Vector.<FlxButton>;
			brushbuttons = new Vector.<FlxButton>;

			if (canvas==null)
			{
				canvas = new FlxSprite(leftmargin,0);
				canvas.createGraphic(FlxG.width-leftmargin,FlxG.height,0xffffffff,true);
				for (i=0;i<canvas.width;i++)
				{
					for (var j:int=0;j<canvas.height;j++)
					{
						//canvas._pixels.setPixel32(i,j,Math.random()<0.5?0xff000000:0xffffffff);
					}
				}
				canvas.resetHelpers();
				canvaspixels = canvas._pixels.getPixels(canvas._pixels.rect);				
				canvaspixelsghost = canvas._pixels.getPixels(canvas._pixels.rect);				
			}
			nhood = new Vector.<Boolean>;
			for (i=0;i<9;i++)
			{
				nhood.push(false);
			}
			canvasrect = new Rectangle(0,0,canvas.width,canvas.height);
			
			this.add(canvas);
			
			var textarray:Array=["q","w","e","r","t","y"];
			
			for (i=0;i<6;i++)
			{
				s = new FlxSprite(0,0);
				s.createGraphic(14,14,0xff000000,true);
				s._pixels.fillRect(new Rectangle(1,1,12,12),0xffffffff);
				s._pixels.fillRect(new Rectangle(1+6-(i+1),1+6-(i+1),2*(i+1),2*(i+1)),0xff000000);
				
				fmt = new TextFormat();
				fmt.font = "Helvetica";
				fmt.size = 10;
				fmt.color=0xffff0000;
				
				tf = new TextField();
				tf.text = textarray[i];
				tf.setTextFormat (fmt);
				tf.autoSize = TextFieldAutoSize.LEFT;
				//tf.antiAliasType=flash.text.AntiAliasType.ADVANCED;
				s._pixels.draw(tf);				
				s.resetHelpers();
				
				
				sup = new FlxSprite(0,0);
				sup.createGraphic(14,14,0xffff0000,true);
				sup._pixels.fillRect(new Rectangle(1,1,12,12),0xffffffff);
				
				sup._pixels.fillRect(new Rectangle(1+6-(i+1),1+6-(i+1),2*(i+1),2*(i+1)),0xff000000);
				
				tf.setTextFormat (fmt);
				sup._pixels.draw(tf);				
				sup.resetHelpers();
				
				b = new FlxButton(0,vmargin1+14*i,Selector.Make(onClickSize,i));
				b.loadGraphic(s,sup);
				this.add(b);
				sizebuttons.push(b);
			}
			
			for (var i:int=0;i<7;i++)
			{
				var s:FlxSprite = new FlxSprite(0,0);
				s.createGraphic(14,14,0xff000000,true);
				var d:Number = 1-(i/6.0);
				s._pixels.fillRect(new Rectangle(1,1,12,12),0xff000000+(255+255*256+255*256*256)*d);
				
				var fmt:TextFormat;
				fmt = new TextFormat();
				fmt.font = "Helvetica";
				fmt.size = 10;
				fmt.color=0xffff0000;
				
				var tf:TextField = new TextField();
				tf.text = (i+1).toString();
				tf.setTextFormat (fmt);
				tf.autoSize = TextFieldAutoSize.LEFT;
				s._pixels.draw(tf);				
				s.resetHelpers();
				
				
				var sup:FlxSprite = new FlxSprite(0,0);
				sup.createGraphic(14,14,0xffff0000,true);
				sup._pixels.fillRect(new Rectangle(1,1,12,12),0xff000000+(255+255*256+255*256*256)*d);
				
				tf.setTextFormat (fmt);
				sup._pixels.draw(tf);				
				sup.resetHelpers();
				
				var b:FlxButton = new FlxButton(0,vmargin2+14*i,Selector.Make(onClickBrush,i));
				b.loadGraphic(s,sup);
				this.add(b);
				brushbuttons.push(b);
			}
			
			//t=0;		
			
			b = new FlxButton(0,vmargin3,randAutomata);
			b.loadGraphic(new FlxSprite(0,0,r1), new FlxSprite(0,0,r2));
			this.add(b);
			
			randAutomata();
			this.onClickBrush(6);
			this.onClickSize(3);
		}
			
		public var lastx:int=-1;
		public var lasty:int=-1;
		//public var t:Number;
		
		override public function update():void
		{		
			//t+=FlxG.elapsed;
			
			if (FlxG.mouse.x>GameState.leftmargin)
			{
				if ( (FlxG.mouse.pressed() && (lastx!=FlxG.mouse.x || lasty!=FlxG.mouse.y)) 
					||
					FlxG.mouse.justPressed()
				)
				{
					paint(FlxG.mouse.x-leftmargin,FlxG.mouse.y);
				}
			}
			
			lastx=FlxG.mouse.x;
			lasty=FlxG.mouse.y;
			
			if (FlxG.keys.justPressed("ONE"))
			{
				onClickBrush(0);
			}
			if (FlxG.keys.justPressed("TWO"))
			{
				onClickBrush(1);
			}
			if (FlxG.keys.justPressed("THREE"))
			{
				onClickBrush(2);
			}
			if (FlxG.keys.justPressed("FOUR"))
			{
				onClickBrush(3);
			}
			if (FlxG.keys.justPressed("FIVE"))
			{
				onClickBrush(4);
			}
			if (FlxG.keys.justPressed("SIX"))
			{
				onClickBrush(5);
			}
			if (FlxG.keys.justPressed("SEVEN"))
			{
				onClickBrush(6);
			}
			
			if (FlxG.keys.justPressed("S"))
			{
				randAutomata();
			}
			
			if (FlxG.keys.justPressed("Q"))
			{
				onClickSize(0);
			}
			if (FlxG.keys.justPressed("W"))
			{
				onClickSize(1);
			}
			if (FlxG.keys.justPressed("E"))
			{
				onClickSize(2);
			}
			if (FlxG.keys.justPressed("R"))
			{
				onClickSize(3);
			}
			if (FlxG.keys.justPressed("T"))
			{
				onClickSize(4);
			}
			if (FlxG.keys.justPressed("Y"))
			{
				onClickSize(5);
			}
			
			super.update();
		}
		
		public function paint(px:int,py:int):void
		{
			var x1:int=Math.max(px-(mySize+1)*3,0);
			var x2:int=Math.min(px+(mySize+1)*3,canvas.width);
			var y1:int=Math.max(py-(mySize+1)*3,0);
			var y2:int=Math.min(py+(mySize+1)*3,canvas.height);
			
			canvaspixels.position=0;
			canvaspixelsghost.position=0;
			canvaspixelsghost.writeBytes(canvaspixels, 0, canvaspixels.length);
			
			for (var i:int=x1;i<x2;i++)
			{
				for (var j:int=y1;j<y2;j++)
				{
					processPixel(i,j);
				}
			}
			canvaspixels.position=0;
			canvas._pixels.setPixels(canvasrect,canvaspixels);
			GameState.canvas.resetHelpers();
			
		}
		
		public static var mySize:int=2;
		private var canvasrect:Rectangle;
		
		public function getPixel(i:int,j:int):int
		{
			canvaspixelsghost.position=0;
			if (i<0 || i>=canvasrect.width || j<0 || j>=canvasrect.height)
					return 1;
			return canvaspixelsghost[4*(i+canvasrect.width*j)+1]==0 ? 0 : 1;
		}//as an optimization, could add padding around the canvas sprite that would always just have 1s
		
		public function processPixel(i:int,j:int):void
		{
			var n:uint = 1*getPixel(i-1,j-1) + 2*getPixel(i,j-1) + 4*getPixel(i+1,j-1) +
					     8*getPixel(i-1,j-0) + 16*getPixel(i,j-0) + 32*getPixel(i+1,j-0) +
						 64*getPixel(i-1,j+1) + 128*getPixel(i,j+1) + 256*getPixel(i+1,j+1);
			//trace(n);
			canvaspixels.position=4*(i+canvasrect.width*j); 			
			canvaspixels.writeUnsignedInt(AutomataManager.CurrentAutomata[myBrush].tick(n)?0xff000000:0xffffffff);
			//canvaspixels[i+canvas.width*j]=0xff000000;
//			canvas._pixels.setPixel32(i,j,0xff000000);
			//get information about pixels in the vicinity
		}
		
		public function onClickSize(n:int):void
		{
			for (var i:int=0;i<6;i++)
			{
				sizebuttons[i].on=i==n;
			}
			mySize=n;
		}
		
		public static var myBrush:int=0;
		
		
		public function onClickBrush(n:int):void
		{
			myBrush=n;
			for (var i:int=0;i<7;i++)
			{
				brushbuttons[i].on=i==n;
			}						
		}
	}
	
}

class Selector
{
	private var _onClick:Function;
	private var _n:int;
	
	public static function Make(f:Function,n:int):Function
	{
		var s:Selector = new Selector(f,n);
		return s.onClick;
	}
	
	public function Selector(f:Function,n:int)
	{
		_onClick=f;
		_n=n;
	}
	
	public function onClick():void
	{
		_onClick(_n);	
	}		
}